﻿using System;
using Foundation;
using Syncfusion.SfChart.iOS;
using UIKit;

namespace Chart_GettingStarted
{
	public partial class ViewController : UIViewController
	{
		protected ViewController(IntPtr handle) : base(handle)
		{
			// Note: this .ctor should not contain any initialization logic.
		}

		public override void DidReceiveMemoryWarning()
		{
			base.DidReceiveMemoryWarning();
			// Release any cached data, images, etc that aren't in use.
		}

		SFChart chart;

		public override void ViewDidLoad()
		{
			base.ViewDidLoad();

			chart = new SFChart();
			chart.Frame = new CoreGraphics.CGRect(0, 0, View.Frame.Width, View.Frame.Height - 100);

			UITextView label = new UITextView();
			label.Frame = new CoreGraphics.CGRect(0, View.Frame.Height - 100, View.Frame.Width, 100);
			//Adding Primary Axis for the Chart.
			SFDateTimeAxis primaryAxis = new SFDateTimeAxis();
			chart.PrimaryAxis = primaryAxis;

			//Adding Secondary Axis for the Chart.
			SFNumericalAxis secondaryAxis = new SFNumericalAxis();
			chart.SecondaryAxis = secondaryAxis;

			//Defining the data source for the Chart.
			ChartDataModel dataModel = new ChartDataModel();
			chart.DataSource = dataModel as SFChartDataSource;
			CustomDelegate chartDelegate = new CustomDelegate(label, dataModel.DataPoints, dataModel.DataPoints1, dataModel.DataPoints2);
			chart.Delegate = chartDelegate;
			chart.AddChartBehavior(new SFChartTrackballBehavior());
			//Adding our Chart as a sub view.
			this.View.AddSubview(chart);
			this.View.AddSubview(label);
		}

		public override void ViewDidLayoutSubviews()
		{
			//chart.Frame = this.View.Frame;
			base.ViewDidLayoutSubviews();
		}

	}

	public class CustomDelegate : SFChartDelegate
	{
		NSMutableArray dataPoints;
		NSMutableArray dataPoints1;
		NSMutableArray dataPoints2;
		UITextView label;


		public CustomDelegate(UITextView label, NSMutableArray dataPoints, NSMutableArray dataPoints1, NSMutableArray dataPoints2)
		{
			this.label = label;
			this.dataPoints = dataPoints;
			this.dataPoints1 = dataPoints1;
			this.dataPoints2 = dataPoints2;
		}

		public override void DidTrackballLabelsGenerate(SFChart chart, NSArray pointsInfo)
		{
			for (nuint i = 0; i < (nuint)pointsInfo.Count; i++)
			{
				SFChartPointInfo chartPointInfo = pointsInfo.GetItem<SFChartPointInfo>(i);
				DateTime date = NSDateToDateTime((chartPointInfo.Data.XValue) as NSDate);
				NSObject dataPointIndex = chartPointInfo.ValueForKey(new NSString("index"));
				NSString indexString = (Foundation.NSString)dataPointIndex.ToString();
				nuint index = nuint.Parse(indexString);
				var yValue1 = this.dataPoints.GetItem<SFChartDataPoint>(index).YValue;
				var yValue2 = this.dataPoints1.GetItem<SFChartDataPoint>(index).YValue;
				var yValue3 = this.dataPoints2.GetItem<SFChartDataPoint>(index).YValue;
				label.Text = "XValue: " + date.ToString() + "\n" + "StackingColumnSeries1: " + yValue1.ToString() + "\n" + "StackingColumnSeries2: " + yValue2.ToString() + "\n" + "AreaSeries: " + yValue3.ToString();
			}
		}

		public DateTime NSDateToDateTime(NSDate date)
		{
			DateTime reference = TimeZone.CurrentTimeZone.ToLocalTime(new DateTime(2001, 1, 1, 0, 0, 0));
			return reference.AddSeconds(date.SecondsSinceReferenceDate);
		}
	}

	public class ChartDataModel : SFChartDataSource
	{
		public NSMutableArray DataPoints, DataPoints1, DataPoints2;
		NSCalendar calendar;


		public ChartDataModel()
		{
			DataPoints = new NSMutableArray();
			DataPoints1 = new NSMutableArray();
			DataPoints2 = new NSMutableArray();

			calendar = new NSCalendar(NSCalendarType.Gregorian);
			NSDateComponents comp = new NSDateComponents();
			comp.Day = 1;
			comp.Month = 1;
			comp.Year = 2015;
			comp.Hour = 0;
			comp.Minute = 0;
			comp.Second = 0;


			NSDate date = calendar.DateFromComponents(comp);
			SFChartDataPoint datas = new SFChartDataPoint(NSObject.FromObject(date), NSObject.FromObject(10));
			SFChartDataPoint datas1 = new SFChartDataPoint(NSObject.FromObject(date), NSObject.FromObject(20));
			SFChartDataPoint datas2 = new SFChartDataPoint(NSObject.FromObject(date), NSObject.FromObject(25));
			DataPoints.Add(datas);
			DataPoints1.Add(datas1);
			DataPoints2.Add(datas2);

			NSDateComponents dateComp = new NSDateComponents();
			dateComp.Month = 1;

			date = calendar.DateByAddingComponents(dateComp, date, NSCalendarOptions.None);
			datas = new SFChartDataPoint(NSObject.FromObject(date), NSObject.FromObject(31));
			datas1 = new SFChartDataPoint(NSObject.FromObject(date), NSObject.FromObject(40));
			datas2 = new SFChartDataPoint(NSObject.FromObject(date), NSObject.FromObject(35));
			DataPoints.Add(datas);
			DataPoints1.Add(datas1);
			DataPoints2.Add(datas2);

			date = calendar.DateByAddingComponents(dateComp, date, NSCalendarOptions.None);
			datas = new SFChartDataPoint(NSObject.FromObject(date), NSObject.FromObject(20));
			datas1 = new SFChartDataPoint(NSObject.FromObject(date), NSObject.FromObject(15));
			datas2 = new SFChartDataPoint(NSObject.FromObject(date), NSObject.FromObject(30));
			DataPoints.Add(datas);
			DataPoints1.Add(datas1);
			DataPoints2.Add(datas2);

			date = calendar.DateByAddingComponents(dateComp, date, NSCalendarOptions.None);
			datas = new SFChartDataPoint(NSObject.FromObject(date), NSObject.FromObject(45));
			datas1 = new SFChartDataPoint(NSObject.FromObject(date), NSObject.FromObject(55));
			datas2 = new SFChartDataPoint(NSObject.FromObject(date), NSObject.FromObject(20));
			DataPoints.Add(datas);
			DataPoints1.Add(datas1);
			DataPoints2.Add(datas2);

			date = calendar.DateByAddingComponents(dateComp, date, NSCalendarOptions.None);
			datas = new SFChartDataPoint(NSObject.FromObject(date), NSObject.FromObject(10));
			datas1 = new SFChartDataPoint(NSObject.FromObject(date), NSObject.FromObject(20));
			datas2 = new SFChartDataPoint(NSObject.FromObject(date), NSObject.FromObject(30));
			DataPoints.Add(datas);
			DataPoints1.Add(datas1);
			DataPoints2.Add(datas2);

		}


		public override nint NumberOfSeriesInChart(SFChart chart)
		{
			return 3;

		}


		public override SFSeries GetSeries(SFChart chart, nint index)
		{
			if (index == 0)
			{
				SFStackingColumnSeries series1 = new SFStackingColumnSeries();
				return series1;
			}
			else if (index == 1)
			{
				SFStackingColumnSeries series2 = new SFStackingColumnSeries();
				return series2;
			}
			else
			{
				SFAreaSeries series3 = new SFAreaSeries();
				return series3;
			}

		}

		public override SFChartDataPoint GetDataPoint(SFChart chart, nint index, nint seriesIndex)
		{
			if (seriesIndex == 0)
			{
				return DataPoints.GetItem<SFChartDataPoint>((nuint)index);
			}
			else if (seriesIndex == 1)
			{
				return DataPoints1.GetItem<SFChartDataPoint>((nuint)index);
			}
			else
			{
				return DataPoints2.GetItem<SFChartDataPoint>((nuint)index);
			}
		}

		public override nint GetNumberOfDataPoints(SFChart chart, nint index)
		{
			return (int)DataPoints.Count;
		}

	}
}

